<template>
  <md-card>
    <md-card-header v-if="editMode">
      <md-field md-inline>
        <label>{{ title }}</label>
        <md-input v-model="newProductName"></md-input>
      </md-field>
    </md-card-header>

    <md-card-header v-else>
      <div class="md-title">{{ title }}</div>
    </md-card-header>

    <md-card-content v-if="editMode">
      <md-field md-inline>
        <label> {{ desc }}</label>
        <md-input v-model="newProductDescription"></md-input>
      </md-field>
      <md-field md-inline>
        <label> {{ price }}</label>
        <md-input v-model="newProductPrice" type="number"></md-input>
      </md-field>
    </md-card-content>

    <md-card-content v-else>
      <div>
        {{ desc }}
      </div>
      <div>
        {{ price }}
      </div>
    </md-card-content>

    <md-card-actions md-alignment="space-between" v-if="editMode">
      <md-button @click="confirmEdit" class="md-primary md-raised"
        >Confirmar</md-button
      >
      <md-button @click="toggleEditMode" class="md-primary md-raised"
        >Cancelar</md-button
      >
    </md-card-actions>

    <md-card-actions md-alignment="space-between" v-else>
      <md-button @click="toggleEditMode" class="md-primary md-raised"
        >Modificar</md-button
      >
      <md-button @click="deleteProduct" class="md-primary md-raised"
        >Eliminar</md-button
      >
    </md-card-actions>
  </md-card>
</template>

<script>
export default {
  name: "Card",
  props: {
    id: Number,
    title: String,
    desc: String,
    price: Number,
  },
  data() {
    return {
      newProductName: this.title,
      newProductDescription: this.desc,
      newProductPrice: Number(this.price),
      editMode: false,
    };
  },
  methods: {
    toggleEditMode() {
      this.editMode = !this.editMode;
    },
    confirmEdit() {
       var newProduct = {
          id: this.id,
          name: this.newProductName,
          desc: this.newProductDescription,
          price: Number(this.newProductPrice),
        };
        this.$emit("product-to-update", newProduct);
        this.toggleEditMode();
    },
    deleteProduct() {
      var productId = this.id;
      this.$emit("product-to-delete", productId);
    },
  },
};
</script>

<style scoped>
.md-card {
  margin: 30px 10px;
  vertical-align: top;
  display: inline-block;
}
</style>
